
JSB.newAddon = function (mainPath) {

  JSB.require('webviewController');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entrieNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entries")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_engine');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntrieNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntries")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_webApp');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_toolbar');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_onNewExcerpt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_dynamic');


  let defaultEntries = {
      Bing:             { title: '🔍 Bing',           symbol: "🔍", engine: "Bing",     desktop:false, link: "https://www.bing.com/search?q=%s" },
      Baidu:            { title: '🔍 Baidu',          symbol: "🔍", engine: "Baidu",    desktop:false, link: "https://www.baidu.com/s?wd=%s" },
      Zhihu:            { title: '🔍 Zhihu',          symbol: "🔍", engine: "Zhihu",    desktop:false, link: "https://www.zhihu.com/search?type=content&q=%s" },
      Google:           { title: '🔍 Google',         symbol: "🔍", engine: "Google",   desktop:false, link: "https://www.google.com/search?q=%s" },
      BaiduTranslate:   { title: '📔 Baidu',          symbol: "📔", engine: "Baidu",    desktop:false, link: "https://fanyi.baidu.com/#en/zh/%s" },
      Deepl:            { title: '📔 Deepl',          symbol: "📔", engine: "Deepl",    desktop:false, link: "https://www.deepl.com/translator#en/zh/%s" },
      Youdao:           { title: '📔 Youdao',         symbol: "📔", engine: "Youdao",   desktop:false, link: "https://dict.youdao.com/m/result?word=%s&lang=en" },
      GoogleTranslate:  { title: '📔 Google',         symbol: "📔", engine: "Google",   desktop:false, link: "https://translate.google.com/?sl=en&tl=zh-CN&text=%s&op=translate" },
      Thesaurus:        { title: '📔 Thesaurus',      symbol: "📔", engine: "Thesaurus",desktop:false, link: "https://www.thesaurus.com/browse/%s" },
      ChatGLM:          { title: '🤖 智谱清言',        symbol: "🤖", engine: "智谱清言",     desktop:false, link: "https://chatglm.cn/detail?from=apply" },
      Yiyan:            { title: '🤖 文心一言',        symbol: "🤖", engine: "文心一言",     desktop:false, link: "https://yiyan.baidu.com/" },
      ResearchGate:     { title: '🎓 ResearchGate',   symbol: "🎓", engine: "RG",       desktop:false, link: "https://www.researchgate.net/search.Search.html?query=%s" },
      GoogleScholar:    { title: '🎓 Google Scholar', symbol: "🎓", engine: "Scholar",  desktop:false, link: "https://scholar.google.com/scholar?q=%s" }
    }
  let defaultWebAppEntries = {
      Bilibili:         { title: '📺 Bilibili',       symbol: "📺", engine: "Bilibili", desktop:true, link: "https://www.bilibili.com" },
      Notion:           { title: '📝 Notion',         symbol: "📝", engine: "Notion",   desktop:false, link: "https://www.notion.so" },
      Wolai:            { title: '📝 Wolai',          symbol: "📝", engine: "Wolai",    desktop:false, link: "https://www.wolai.com" },    
      Craft:            { title: '📝 Craft',          symbol: "📝", engine: "Craft",    desktop:false, link: "https://docs.craft.do" },
      Flomo:            { title: '📝 Flomo',          symbol: "📝", engine: "Flomo",    desktop:false, link: "https://v.flomoapp.com/mine" },
      Flowus:           { title: '📝 Flowus',         symbol: "📝", engine: "Flowus",   desktop:false, link: "https://flowus.cn" },
      Yinian:           { title: '📝 Yinian',         symbol: "📝", engine: "Yinian",   desktop:true, link: "https://www.yinian.pro/note/" },
      Baiduyun:         { title: '☁️ Baiduyun',        symbol: "☁️", engine: "Baidu",    desktop:true, link: "https://pan.baidu.com/disk/main#/index?category=all" },
    }
  var temSender;

  var MNBrowserClass = JSB.defineClass(
    'MNBrowser : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        // self.appInstance = Application.sharedInstance();
        // self.addonController.mainPath = mainPath;
        // self.addonController.defaultEntries = defaultEntries
        // self.addonController.entries = entries
        // self.addonController.entrieNames = entrieNames
        // self.addonController.defaultWebAppEntries = defaultWebAppEntries
        // self.addonController.webAppEntries = webAppEntries
        // self.addonController.webAppEntrieNames = webAppEntrieNames
        // self.addonController.appearOnNewExcerpt = configOnNewExcerpt.autoAppear;
        // self.addonController.processNewExcerptColor = configOnNewExcerpt.color;
        // self.addonController.autoComment = configOnNewExcerpt.autoComment;
        // self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true;
        self.linkDetected = false
        self.screenImage = getImage(mainPath + `/screen.png`)
        self.linkImage = getImage(mainPath + `/link.png`)

        // self.first = true;
        // } catch (error) {
        // Application.sharedInstance().showHUD(error,self.window,2)
          
        // }
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
// try {
        let entries = getLocalDataByKeyDefault('MNBrowser_entries', defaultEntries)
        let entrieNames = getLocalDataByKeyDefault('MNBrowser_entrieNames',Object.keys(entries));
        let webAppEntries       = getLocalDataByKeyDefault('MNBrowser_webAppEntries',defaultWebAppEntries);
        let webAppEntrieNames   = getLocalDataByKeyDefault('MNBrowser_webAppEntrieNames',Object.keys(webAppEntries));
        let searchOrder         = getLocalDataByKeyDefault('MNBrowser_searchOrder',[2,1,3]);
        let toolbar = getLocalDataByKeyDefault('MNBrowser_toolbar',true);
        let dynamic = getLocalDataByKeyDefault('MNBrowser_dynamic',false);
        // if (self.appInstance.studyController(self.window).studyMode < 3) {
        self.appInstance = Application.sharedInstance();
        // self.addonController = browserController.new();
        if (!self.addonController) {
          self.addonController = browserController.new();
        }
        self.addonController.mainPath = mainPath;
        self.addonController.entries = entries
        self.addonController.entrieNames = entrieNames
        self.addonController.webAppEntries = webAppEntries
        self.addonController.webAppEntrieNames = webAppEntrieNames
        self.addonController.searchOrder = searchOrder
        studyController().view.addSubview(self.addonController.view);
        studyController().refreshAddonCommands();
        self.addonController.view.hidden = true;
        self.addonController.notebookid = notebookid
        self.addonController.webview.loadRequest(
          NSURLRequest.requestWithURL(NSURL.URLWithString(self.addonController.homePageURL))
        );
        addObserver(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection')
        addObserver(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
        // addObserver(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt');
        addObserver(self, 'onCloseView:', 'close');
        addObserver(self, 'receivedSearchInBrowser:', 'searchInBrowser');
        addObserver(self, 'receivedOpenInBrowser:', 'openInBrowser');
        addObserver(self, 'onNewWindow:', 'newWindow');
        // addObserver(self, 'onPasteboardChange:', 'UIPasteboardChangedNotification');
        // addObserver(self, 'onPasteboardChange:', 'UIPasteboardChangedTypesAddedKey');
        // addObserver(self, 'onPasteboardChange:', 'UIPasteboardChangedTypesRemovedKey');
        // addObserver(self, 'onPasteboardChange:', 'UIPasteboardRemovedNotification');

        self.addonController.toolbarOn = toolbar
        self.addonController.webAppButton.hidden = !toolbar
        // self.addonController.webAppEntriesButton.hidden = !toolbar
        // self.addonController.searchButton.hidden = !toolbar
        self.addonController.homeButton.hidden = !toolbar
        self.addonController.goBackButton.hidden = !toolbar
        self.addonController.goForwardButton.hidden = !toolbar
        self.addonController.refreshButton.hidden = !toolbar
        // self.addonController.screenButton.hidden = !toolbarOn
        self.addonController.engineButton.hidden = !toolbar
        var viewFrame = self.addonController.view.bounds;
        if (self.addonController.toolbarOn) {
          self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
        } else {
          self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
        }
        self.addonController.dynamic = dynamic
        // self.customLayoutAddonController();
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      },

      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        if (self.addonController.miniMode) {
          self.addonController.homePage()
          let preFrame = self.addonController.view.frame
          self.addonController.view.hidden = true
          self.addonController.showAllButton()
          let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
          if (self.addonController.view.frame.x < studyFrame.width*0.5) {
            self.addonController.lastFrame.x = 0
          }else{
            self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
          }
          self.addonController.view.frame  = self.addonController.lastFrame
          self.addonController.currentFrame = self.addonController.lastFrame
          self.addonController.show(preFrame)
        }
        self.addonController.view.removeFromSuperview()
        self.newWindowController.view.removeFromSuperview()

        // self.appInstance.studyController(self.window).view.remov(self.addonController.view);
        
        self.watchMode = false;
        self.textSelected = '';
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnNote');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'searchInBrowser');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'close');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'openInBrowser');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'newWindow');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        // self.appInstance.showHUD('test',self.window,2)
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            self.addonController.setSplitScreenFrame(self.addonController.customMode)
            self.addonController.webview.frame = self.addonController.view.bounds
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
        if (!self.newWindowController || self.newWindowController.view.hidden) {return}
        let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
        if (self.newWindowController.miniMode) {
          let oldFrame = self.newWindowController.view.frame
          if (oldFrame.x < studyFrame.width*0.5) {
            self.newWindowController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: oldFrame.height }
          } else {
            self.newWindowController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: oldFrame.height }
          }
        } else if (self.newWindowController.custom) {
          self.addonController.setSplitScreenFrame(self.addonController.customMode)
          self.newWindowController.webview.frame = self.newWindowController.view.bounds
        }else{
          let currentFrame = self.newWindowController.currentFrame
          if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
            currentFrame.x = studyFrame.width-currentFrame.width*0.5              
          }
          if (currentFrame.y >= studyFrame.height) {
            currentFrame.y = studyFrame.height-20              
          }
          self.newWindowController.view.frame = currentFrame
          self.newWindowController.currentFrame = currentFrame
        }
      },

      queryAddonCommandStatus: function () {
        if (self.linkDetected) {
          return {
            image: 'link.png',
            object: self,
            selector: 'toggleAddon:',
            checked: true
          };
        }else{
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: self.watchMode
          };
        }
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub


          //  Application.sharedInstance().showHUD(sender.userInfo.winRect, self.window, 2);

        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        isOnSelection = true
        let textSelected = sender.userInfo.documentController.selectionText
        self.textSelected = encodeURIComponent(sender.userInfo.documentController.selectionText.replaceAll('/', '\\/'));
        self.addonController.selectedText = self.textSelected
        if (self.newWindowController) {
          self.newWindowController.selectedText = self.textSelected
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (self.linkDetected) { 
            // self.appInstance.showHUD("link", self.window, 2);

          self.linkDetected = /^\s?https:\/\/\w+/.test(textSelected)
          if (self.linkDetected) {
            self.linkTimer.invalidate();
          }else{
            delete self.addonController.screenButton.link
            self.addonController.screenButton.setImageForState(self.screenImage,0)
            self.addonController.screenButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.appInstance.studyController(self.window).refreshAddonCommands();
          }
        }else{
          self.linkDetected = /^\s?https:\/\/\w+/.test(textSelected)
            // self.appInstance.showHUD("link", self.window, 2);
          if (self.linkDetected) {
            self.link = textSelected.trim()
            self.addonController.screenButton.link = self.link
            self.addonController.screenButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
            self.addonController.screenButton.setImageForState(self.linkImage,0)
            studyController().refreshAddonCommands();
            self.linkTimer = NSTimer.scheduledTimerWithTimeInterval(2.5, false, function () {
              self.linkTimer.invalidate()
              self.linkDetected = false
              delete self.addonController.screenButton.link
              self.addonController.screenButton.setImageForState(self.screenImage,0)
              self.addonController.screenButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
              studyController().refreshAddonCommands();
            });
          }
        }
        if (!self.watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          if (self.newWindowController) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }

          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (self.newWindowController) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        //watch mode

        // var text = sender.userInfo.documentController.selectionText;
        if (self.textSelected && self.textSelected.length) {
          self.addonController.search(self.textSelected);
          if (self.addonController.dynamic) {
            UIView.animateWithDurationAnimations(0.2,()=>{
              self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
            });
          }
          self.addonController.view.hidden = false;
        }
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        // if (Date.now() - self.dateGetText < 100) {
        //   return
        // }
        // try {
        //   NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPasteboardChange:', 'UIPasteboardChangdNotification');
          
        // } catch (error) {
        // Application.sharedInstance().showHUD(error,self.window,2)
          
        // }
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        let currentNoteId = sender.userInfo.note.noteId
        // Application.sharedInstance().showHUD(self.addonController.watchMode,self.window,2)
        // let note = Database.sharedInstance().getNoteById(sender.userInfo.note.noteId)
        let note = sender.userInfo.note
        // UIPasteboard.generalPasteboard().string = note.notesText
        let text = self.getTextForSearch(note)
        // Application.sharedInstance().showHUD(text,self.window,2)

        self.textSelected = encodeURIComponent(text.replaceAll('/', '\\/'))
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))

        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        if (self.newWindowController) {
          self.newWindowController.selectedText = self.textSelected
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (!self.addonController.view.window) return;

        if (self.viewTimer) self.viewTimer.invalidate();
        if (self.linkDetected) {

          let allNotes = self.getNoteList(note)
          self.linkDetected = allNotes.some(note=>/^\s?https:\/\//.test(note))
          if (self.linkDetected) {
            self.linkTimer.invalidate();
          }else{
            delete self.addonController.screenButton.link
            self.addonController.screenButton.setImageForState(self.screenImage,0)
            self.addonController.screenButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.appInstance.studyController(self.window).refreshAddonCommands();
          }
        }else{
          let allNotes = self.getNoteList(note)
          self.linkDetected = allNotes.some(note=>/^\s?https:\/\//.test(note))
        // Application.sharedInstance().showHUD("check:"+self.linkDetected,self.window,2)

          if (self.linkDetected) {
            self.link = allNotes.filter(note=>/^\s?https:\/\//.test(note))[0].trim()
            self.addonController.screenButton.link = self.link
            self.addonController.screenButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
            self.addonController.screenButton.setImageForState(self.linkImage,0)
            self.appInstance.studyController(self.window).refreshAddonCommands();
            self.linkTimer = NSTimer.scheduledTimerWithTimeInterval(2.5, false, function () {
              self.linkTimer.invalidate()
              self.linkDetected = false
              delete self.addonController.screenButton.link
              self.addonController.screenButton.setImageForState(self.screenImage,0)
              self.addonController.screenButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
              self.appInstance.studyController(self.window).refreshAddonCommands();
            });
          }
        }
        if (!self.watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          if (self.newWindowController) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (self.newWindowController) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        if (self.textSelected && self.textSelected.length) {
          self.addonController.search(self.textSelected);
          if (self.addonController.dynamic) {
            UIView.animateWithDurationAnimations(0.5,()=>{
              self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
            })
          }
          self.addonController.view.hidden = false;
        }
        // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
      },
      onCloseView: function (params) {
        // Application.sharedInstance().showHUD("trst",self.window,2)
        if (!self.appInstance.checkNotifySenderInWindow(params, self.window)) return; // Don't process message from other window

        self.watchMode = false;
        self.appInstance.studyController(self.window).refreshAddonCommands();
        var url = self.addonController.homePageURL
        // var url = 'https://go.itab.link/'
        self.addonController.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'

        self.addonController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
        // custom = true;
        // self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);

        // self.customLayoutAddonController(123);
        // try {
        // self.layoutAddonController(0,0,true)

        // } catch (error) {
        // Application.sharedInstance().showHUD(error,self.window,2)

        // }
      },
      onNewWindow: function (sender) {
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) {
        // Application.sharedInstance().showHUD("other window",self.window,2)
        return; // Don't process message from other window
        }
        if (!self.newWindowController) {
          self.newWindowController = browserController.new();
          self.newWindowController.mainPath = mainPath;
          self.newWindowController.entries = self.addonController.entries
          self.newWindowController.entrieNames = self.addonController.entrieNames
          self.newWindowController.webAppEntries = self.addonController.webAppEntries
          self.newWindowController.webAppEntrieNames = self.addonController.webAppEntrieNames
          self.newWindowController.searchOrder = self.addonController.searchOrder
          self.newWindowController.addonBar = self.addonController.addonBar
          self.newWindowController.view.hidden = true
          studyController().view.addSubview(self.newWindowController.view);
          self.newWindowController.view.frame = {x:50,y:100,width:417,height:450}
          self.newWindowController.currentFrame = {x:50,y:100,width:417,height:450}
        }
        if (self.newWindowController.view.hidden) {
          self.newWindowController.show(self.newWindowController.addonBar.frame)
        }
        try {
        if (sender.userInfo.desktop) {
          self.newWindowController.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
        }else{
          self.newWindowController.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
        }
        let toolbar = getLocalDataByKeyDefault('MNBrowser_toolbar',true);
        self.newWindowController.toolbarOn = toolbar
        self.newWindowController.webAppButton.hidden = !toolbar
        // self.newWindowController.webAppEntriesButton.hidden = !toolbar
        // self.newWindowController.searchButton.hidden = !toolbar
        self.newWindowController.homeButton.hidden = !toolbar
        self.newWindowController.goBackButton.hidden = !toolbar
        self.newWindowController.goForwardButton.hidden = !toolbar
        self.newWindowController.refreshButton.hidden = !toolbar
        // self.newWindowController.screenButton.hidden = !toolbarOn
        self.newWindowController.engineButton.hidden = !toolbar
        var viewFrame = self.newWindowController.view.bounds;
        if (self.newWindowController.toolbarOn) {
          self.newWindowController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
        } else {
          self.newWindowController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
        }
        self.newWindowController.isMainWindow = false
        self.newWindowController.webview.hidden = false;
        // Application.sharedInstance().showHUD(userInfo.url, self.window, 5);
        self.newWindowController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(sender.userInfo.url)));
        } catch (error) {
        Application.sharedInstance().showHUD(error,self.window,2)
          
        }
      },
      onPasteboardChange: function () {
        Application.sharedInstance().showHUD("check:",self.window,2)

      },
      receivedSearchInBrowser: function (sender) {
        // Application.sharedInstance().showHUD("check:",self.appInstance.focusWindow,2)
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        if (sender.userInfo.noteid) {
          let note = getNoteById(sender.userInfo.noteid)
          let text = self.getTextForSearch(note)
          self.addonController.selectedText = text
          self.addonController.search(self.textSelected)
        }else{
          self.textSelected = encodeURIComponent(sender.userInfo.text.replaceAll('/', '\\/'));
          self.addonController.selectedText = self.textSelected
          self.addonController.search(self.textSelected)
        }
        if (self.addonController.view.hidden) {
          self.addonController.show()
          self.appInstance.studyController(self.window).view.bringSubviewToFront(self.addonController.view)
        }
      },
      receivedOpenInBrowser: function (sender) {
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        // if (!self.appInstance.checkNotifySenderInWindow(sender, self.appInstance.focusWindow)) {
        // Application.sharedInstance().showHUD("reject",self.window,2)

        // return; // Don't process message from other window
        // }
        // if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) {
        // // Application.sharedInstance().showHUD("other window",self.window,2)
        // return; // Don't process message from other window
        // }
        // Application.sharedInstance().showHUD("text"+sender.userInfo,self.window,2)
        // self.textSelected = encodeURIComponent(sender.userInfo.text.replaceAll('/', '\\/'));
        // self.addonController.selectedText = self.textSelected
        // self.addonController.search(self.textSelected)
        // self.webview.loadRequest
        self.addonController.webview.loadRequest(
            NSURLRequest.requestWithURL(NSURL.URLWithString(sender.userInfo.url))
          );
        self.addonController.show()
        // self.addonController.view.hidden = false
        // self.addonController.webview.hidden = false
        // self.addonController.moveButton.hidden = false
        // self.addonController.maxButton.hidden = false

      },
      toggleAddon: function (sender) {
        try {
          

        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          self.addonController.addonBar = self.addonBar
        }
        if (self.checkWatchMode()) { return }
        if (self.linkDetected) {
          self.addonController.webview.loadRequest(
            NSURLRequest.requestWithURL(NSURL.URLWithString(self.link))
          );
          if (self.addonController.view.hidden) {
            self.addonController.show(self.addonBar.frame)
          }
          return
        }

        if (self.addonController.view.hidden) {
          if (self.isFirst) {
            // Application.sharedInstance().showHUD("first",self.window,2)

            let buttonFrame = self.addonBar.frame
            let width = self.appInstance.osType !== 1 ? 419 : 365
            if (buttonFrame.x === 0) {
              self.addonController.view.frame = {x:40,y:buttonFrame.y,width:width,height:450}
            }else{
              self.addonController.view.frame = {x:buttonFrame.x-width,y:buttonFrame.y,width:width,height:450}
            }
            self.addonController.currentFrame = self.addonController.view.frame
            self.isFirst = false;
          }
          self.addonController.show(self.addonBar.frame)
          // self.addonController.view.hidden = false
          // self.addonController.webview.hidden = false
        } else {
          if (self.textProcessed || self.watchMode) {
            // self.addonController.view.hidden = true;
            if (self.addonController.miniMode) {
              let preFrame = self.addonController.view.frame
              self.addonController.view.hidden = true
              self.addonController.showAllButton()
              let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
              if (self.addonController.view.frame.x < studyFrame.width*0.5) {
                self.addonController.lastFrame.x = 0
              }else{
                self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
              }
              self.addonController.view.frame  = self.addonController.lastFrame
              self.addonController.currentFrame = self.addonController.lastFrame
              self.addonController.show(preFrame)
            }else{
              self.addonController.hide(self.addonBar.frame)
            }
            self.watchMode = false;
            self.appInstance.studyController(self.window).refreshAddonCommands();
            return;
          }
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); // For dismiss keyboard on iOS
        });
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();

        // Application.sharedInstance().showHUD("process:1",self.window,2)
        var text = self.textSelected;
        if (text && text.length  && (Date.now() - self.dateGetText < 5000)) {
        // Application.sharedInstance().showHUD("process:2",self.window,2)

          // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
          self.addonController.webview.stopLoading();
          self.addonController.search(text);
          // self.addonController.homePage(text);
          // self.customLayoutAddonController();
          if (self.addonController.dynamic && temSender) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          // self.addonController.view.hidden = false;
          self.addonController.miniMode = false
          // self.addonController.screenButton.hidden = false
          // self.addonController.searchButton.hidden = false
          // self.addonController.engineButton.hidden = !self.addonController.toolbarOn

          if (self.addonController.dynamic) {
            self.addonController.toolbarOn = false
            self.addonController.custom = false;
            self.addonController.customMode = "None"
            self.addonController.engineButton.hidden = true
            self.addonController.webAppButton.hidden = true
            self.addonController.homeButton.hidden = true
            // self.addonController.webAppEntriesButton.hidden = true
            // self.addonController.screenButton.hidden = true
            self.addonController.engineButton.hidden = true
            var viewFrame = self.addonController.view.bounds;
            self.addonController.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
          }
          self.textProcessed = true
        } else {
        // Application.sharedInstance().showHUD("process:3",self.window,2)

          self.textProcessed = true
          // self.addonController.homePage(text);
          if (self.addonController.dynamic && temSender) {
        // Application.sharedInstance().showHUD("process:3",self.window,2)
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.engineButton.hidden = !self.addonController.toolbarOn
        }
  
} catch (error) {
          Application.sharedInstance().showHUD(error,self.window,2)
  
}
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
        NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entrieNames")
        NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entries")
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_engine');
        NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntrieNames")
        NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntries")
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_webApp');
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_toolbar');
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_onNewExcerpt');
        NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_dynamic');
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNBrowserClass.prototype.layoutAddonController = function (rectStr, arrowNum) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
    // this.appInstance.showHUD('x:'+x+';y:'+Y,this.window,2)
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNBrowserClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
      w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  MNBrowserClass.prototype.checkWatchMode = function () {
    if (Date.now() - this.dateNow < 500) {
      this.watchMode = true;
      Application.sharedInstance().showHUD("Watch mode", this.window, 2)
      this.appInstance.studyController(this.window).refreshAddonCommands();
      this.addonController.webview.hidden = false
      this.addonController.view.hidden = false
      this.addonController.showAllButton()

      // if (this.addonController.view.hidden) {
      //   this.addonController.show(this.addonBar.frame)
      // }
      return true;
    }else{
      this.dateNow = Date.now()
      return false
    }
  };
  MNBrowserClass.prototype.getNoteList = function (note) {
    let noteList = []
    if (note.noteTitle) {
      noteList.push(note.noteTitle)
    }
    if (note.excerptText && !note.excerptPic) {
      noteList.push(note.excerptText)
    }
    return noteList.concat(note.comments.filter(comment=>comment.type="TextNote").map(comment=>comment.text))
  };
  MNBrowserClass.prototype.getTextForSearch = function (note) {
    let order = this.addonController.searchOrder
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          if (noteText.length) {
            text =  noteText[0].text
          }
          break;
        default:
          break;
      }
      if (text) {
        return text
      }
    }
  return ""
  }
  return MNBrowserClass;
};

